/// <reference path="mwg.d.ts" />
/// <reference path="mwg.structure.d.ts" />
declare var Module: any;
declare module org {
    module mwg {
        module ml {
            module common {
                module matrix {
                    module blassolver {
                        module blas {
                            class JSBlas implements org.mwg.ml.common.matrix.blassolver.blas.Blas {
                                private netlib;
                                private c_dgemm;
                                private c_dgetrs;
                                private c_dgetri;
                                private c_dorgqr;
                                private c_dgesdd;
                                private c_dgeqrf;
                                private c_dgetrf;
                                constructor();
                                dgemm(transA: org.mwg.ml.common.matrix.TransposeType, transB: org.mwg.ml.common.matrix.TransposeType, m: number, n: number, k: number, alpha: number, matA: Float64Array, offsetA: number, ldA: number, matB: Float64Array, offsetB: number, ldB: number, beta: number, matC: Float64Array, offsetC: number, ldC: number): void;
                                dgetrs(transA: org.mwg.ml.common.matrix.TransposeType, dim: number, nrhs: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, matB: Float64Array, offsetB: number, ldB: number, info: Int32Array): void;
                                dgetri(dim: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, work: Float64Array, offsetWork: number, ldWork: number, info: Int32Array): void;
                                dgetrf(rows: number, columns: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, info: Int32Array): void;
                                dorgqr(m: number, n: number, k: number, matA: Float64Array, offsetA: number, ldA: number, taw: Float64Array, offsetTaw: number, work: Float64Array, offsetWork: number, lWork: number, info: Int32Array): void;
                                dgeqrf(m: number, n: number, matA: Float64Array, offsetA: number, ldA: number, taw: Float64Array, offsetTaw: number, work: Float64Array, offsetwork: number, lWork: number, info: Int32Array): void;
                                dgesdd(jobz: string, m: number, n: number, data: Float64Array, lda: number, s: Float64Array, u: Float64Array, ldu: number, vt: Float64Array, ldvt: number, work: Float64Array, length: number, iwork: Int32Array, info: Int32Array): void;
                                connect(): void;
                                disconnect(): void;
                            }
                        }
                    }
                }
            }
        }
    }
}
declare module org {
    module mwg {
        module ml {
            abstract class AbstractMLNode extends org.mwg.plugin.AbstractNode {
                static FROM_SEPARATOR: string;
                static FROM: string;
                constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                static requireNotNull(obj: any, message: string): void;
                illegalArgumentIfFalse(condition: boolean, errorMessage: string): void;
                extractFeatures(callback: org.mwg.Callback<Float64Array>): void;
            }
            interface AnomalyDetectionNode extends org.mwg.Node {
                learn(callback: org.mwg.Callback<boolean>): void;
                classify(callback: org.mwg.Callback<boolean>): void;
            }
            interface ClassificationNode extends org.mwg.Node {
                learn(expectedClass: number, callback: org.mwg.Callback<boolean>): void;
                classify(callback: org.mwg.Callback<number>): void;
            }
            interface ClusteringNode extends org.mwg.Node {
                learn(callback: org.mwg.Callback<boolean>): void;
                inferCluster(callback: org.mwg.Callback<number>): void;
            }
            class MLPlugin extends org.mwg.structure.StructurePlugin {
                constructor();
            }
            interface ProfilingNode extends org.mwg.Node {
                learn(callback: org.mwg.Callback<boolean>): void;
                predict(callback: org.mwg.Callback<Float64Array>): void;
            }
            interface ProgressReporter {
                updateProgress(value: number): void;
                isCancelled(): boolean;
                updateInformation(info: string): void;
            }
            interface RegressionNode extends org.mwg.Node {
                learn(output: number, callback: org.mwg.Callback<boolean>): void;
                extrapolate(callback: org.mwg.Callback<number>): void;
            }
            module algorithm {
                module anomalydetector {
                    class InterquartileRangeOutlierDetectorNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.AnomalyDetectionNode {
                        static MAX_BUFFER_LIMIT: number;
                        static NAME: string;
                        private static INTERNAL_VALUE_BUFFER_KEY;
                        static BUFFER_SIZE_KEY: string;
                        static BUFFER_SIZE_DEF: number;
                        static INPUT_DIM_KEY: string;
                        static INPUT_DIM_DEF: number;
                        static UPPER_PERCENTILE: number;
                        static LOWER_PERCENTILE: number;
                        static RANGE_COEF: number;
                        static UPPER_BOUND_KEY_PREFIX: string;
                        static LOWER_BOUND_KEY_PREFIX: string;
                        private static enforcer;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        addValue(value: Float64Array): boolean;
                        checkValue(value: Float64Array, lowerBounds: Float64Array, upperBounds: Float64Array): boolean;
                        learn(callback: org.mwg.Callback<boolean>): void;
                        classify(callback: org.mwg.Callback<boolean>): void;
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                    }
                }
                module preprocessing {
                    class PCA {
                        private _data;
                        private _olddim;
                        private _min;
                        private _max;
                        private _sigma;
                        private _avg;
                        private _information;
                        private _processType;
                        private _percentToRetain;
                        private _bestDim;
                        _svdDecompose: org.mwg.ml.common.matrix.SVDDecompose;
                        static EPS: number;
                        private static _matrixV;
                        static NOPROCESS: number;
                        static CENTER_ON_AVG: number;
                        static NORMALIZE: number;
                        get_bestDim(): number;
                        get_data(): org.mwg.struct.Matrix;
                        private static clone(data);
                        getDimensionInfo(): Float64Array;
                        get_min(): Float64Array;
                        get_max(): Float64Array;
                        get_avg(): Float64Array;
                        get_sigma(): Float64Array;
                        normalizeData(data: org.mwg.struct.Matrix): void;
                        convertVector(data: Float64Array): Float64Array;
                        convertSpace(initial: org.mwg.ml.common.matrix.VolatileMatrix): org.mwg.struct.Matrix;
                        setDimension(dim: number): void;
                        inverseNormalizeData(data: org.mwg.struct.Matrix): void;
                        inverseConvertVector(data: Float64Array): Float64Array;
                        inverseConvertSpace(initial: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        getTransformationVector(): org.mwg.struct.Matrix;
                        private calculateMinMaxAvg();
                        private static shiftColumn(data, shift, workInPlace);
                        private static inverseShift(data, shift, workInPlace);
                        retainDynamic(svector: Float64Array): number;
                        static retain(svector: Float64Array, percent: number): number;
                        constructor(data: org.mwg.struct.Matrix, processType: number);
                    }
                }
                module profiling {
                    class GaussianMixtureNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.ProfilingNode {
                        static NAME: string;
                        static MIN: string;
                        static MAX: string;
                        static AVG: string;
                        static COV: string;
                        static LEVEL: string;
                        static LEVEL_DEF: number;
                        static WIDTH: string;
                        static WIDTH_DEF: number;
                        static COMPRESSION_FACTOR: string;
                        static COMPRESSION_FACTOR_DEF: number;
                        static COMPRESSION_ITER: string;
                        static COMPRESSION_ITER_DEF: number;
                        static THRESHOLD: string;
                        static THRESHOLD_DEF: number;
                        static PRECISION: string;
                        static INTERNAL_SUBGAUSSIAN: string;
                        private static INTERNAL_SUM_KEY;
                        private static INTERNAL_SUMSQUARE_KEY;
                        private static INTERNAL_TOTAL_KEY;
                        private static INTERNAL_MIN_KEY;
                        private static INTERNAL_MAX_KEY;
                        private static enforcer;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                        type(attributeName: string): number;
                        get(attributeName: string): any;
                        learn(callback: org.mwg.Callback<boolean>): void;
                        learnVector(values: Float64Array, callback: org.mwg.Callback<boolean>): void;
                        private checkInside(min, max, precisions, threshold, level);
                        private filter(result, features, precisions, threshold, level);
                        predict(callback: org.mwg.Callback<Float64Array>): void;
                        getLevel(): number;
                        getWidth(): number;
                        getCompressionFactor(): number;
                        getCompressionIter(): number;
                        private updateLevel(newLevel);
                        private createLevel(values, level, width, compressionFactor, compressionIter, precisions, threshold);
                        private checkAndCompress(width, compressionFactor, compressionIter, precisions, threshold);
                        private move(subgaus);
                        query(level: number, min: Float64Array, max: Float64Array, callback: org.mwg.Callback<org.mwg.ml.algorithm.profiling.ProbaDistribution>): void;
                        generateDistributions(level: number, callback: org.mwg.Callback<org.mwg.ml.algorithm.profiling.ProbaDistribution>): void;
                        toString(): string;
                        private internallearn(values, width, compressionFactor, compressionIter, precisions, threshold, createNode);
                        getNumberOfFeatures(): number;
                        getSum(): Float64Array;
                        getSumSquares(): Float64Array;
                        getProbability(featArray: Float64Array, err: Float64Array, normalizeOnAvg: boolean): number;
                        getProbabilityArray(featArray: Array<Float64Array>, err: Float64Array, normalizeOnAvg: boolean): Float64Array;
                        getTotal(): number;
                        getAvg(): Float64Array;
                        getCovarianceArray(avg: Float64Array, err: Float64Array): Float64Array;
                        getCovariance(avg: Float64Array, err: Float64Array): org.mwg.struct.Matrix;
                        getMin(): Float64Array;
                        getMax(): Float64Array;
                        getSubGraph(): Float64Array;
                        static distance(features: Float64Array, avg: Float64Array, precisions: Float64Array): number;
                    }
                    class GaussianNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.ProfilingNode {
                        static NAME: string;
                        static MIN: string;
                        static MAX: string;
                        static AVG: string;
                        static COV: string;
                        static PRECISION: string;
                        private static INTERNAL_SUM_KEY;
                        private static INTERNAL_SUMSQUARE_KEY;
                        private static INTERNAL_TOTAL_KEY;
                        private static INTERNAL_MIN_KEY;
                        private static INTERNAL_MAX_KEY;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                        type(attributeName: string): number;
                        get(attributeName: string): any;
                        learn(callback: org.mwg.Callback<boolean>): void;
                        learnVector(values: Float64Array, callback: org.mwg.Callback<boolean>): void;
                        predict(callback: org.mwg.Callback<Float64Array>): void;
                        toString(): string;
                        getNumberOfFeatures(): number;
                        getSum(): Float64Array;
                        getSumSquares(): Float64Array;
                        getProbability(featArray: Float64Array, err: Float64Array, normalizeOnAvg: boolean): number;
                        getExponent(featArray: Float64Array): number;
                        getProbabilityArray(featArray: Array<Float64Array>, err: Float64Array, normalizeOnAvg: boolean): Float64Array;
                        getTotal(): number;
                        getAvg(): Float64Array;
                        getCovarianceArray(avg: Float64Array, err: Float64Array): Float64Array;
                        getCovariance(avg: Float64Array, err: Float64Array): org.mwg.struct.Matrix;
                        getMin(): Float64Array;
                        getMax(): Float64Array;
                        static distance(features: Float64Array, avg: Float64Array, precisions: Float64Array): number;
                    }
                    class GaussianSlotNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.ProfilingNode {
                        static NAME: string;
                        static SLOTS_NUMBER: string;
                        static SLOTS_NUMBER_DEF: number;
                        static PERIOD_SIZE: string;
                        static PERIOD_SIZE_DEF: number;
                        private static INTERNAL_FEATURES_NUMBER;
                        private static INTERNAL_TOTAL_KEY;
                        private static INTERNAL_MIN_KEY;
                        private static INTERNAL_MAX_KEY;
                        private static INTERNAL_SUM_KEY;
                        private static INTERNAL_SUMSQUARE_KEY;
                        private static enforcer;
                        learn(callback: org.mwg.Callback<boolean>): void;
                        private static timeSensitivity(currentTime, sensitivity);
                        learnArray(values: Float64Array): void;
                        predict(callback: org.mwg.Callback<Float64Array>): void;
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                        get(attributeName: string): any;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        static getIntTime(time: number, numOfSlot: number, periodSize: number): number;
                        private update(total, min, max, sum, sumSquare, values, slot, features, index, indexSquare);
                        getMin(): Float64Array;
                        getMax(): Float64Array;
                        getSum(): Float64Array;
                        getSumSquare(): Float64Array;
                        getTotal(): Int32Array;
                        getAvg(): Float64Array;
                    }
                    class GaussianTreeNode extends org.mwg.ml.algorithm.profiling.GaussianNode implements org.mwg.ml.ProfilingNode {
                        static NAME: string;
                        static THRESHOLD: string;
                        static THRESHOLD_DEF: number;
                        private static INTERNAL_KDROOT;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        learn(callback: org.mwg.Callback<boolean>): void;
                        internalLearn(values: Float64Array, features: Float64Array, callback: org.mwg.Callback<boolean>): void;
                        getNumNodes(): number;
                        predict(callback: org.mwg.Callback<Float64Array>): void;
                        predictValue(values: Float64Array, callback: org.mwg.Callback<number>): void;
                    }
                    class KMeans {
                        getClusterIds(data: Array<Float64Array>, numOfCluster: number, numOfIterations: number, div: Float64Array): Array<Int32Array>;
                        private calculateCategory(values, centroids, div);
                        static distance(features: Float64Array, avg: Float64Array, precisions: Float64Array): number;
                    }
                    class ProbaDistribution {
                        distributions: org.mwg.ml.common.matrix.operation.MultivariateNormalDistribution[];
                        total: Int32Array;
                        global: number;
                        constructor(total: Int32Array, distributions: org.mwg.ml.common.matrix.operation.MultivariateNormalDistribution[], global: number);
                        calculate(features: Float64Array): number;
                        calculateArray(features: Array<Float64Array>, reporter: org.mwg.ml.ProgressReporter): Float64Array;
                        addUpProbabilities(features: Array<Float64Array>): number;
                        compareProbaDistribution(other: org.mwg.ml.algorithm.profiling.ProbaDistribution, features: Array<Float64Array>): Float64Array;
                    }
                }
                module regression {
                    class LiveLinearRegressionNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.RegressionNode {
                        static ALPHA_KEY: string;
                        static ALPHA_DEF: number;
                        static LAMBDA_KEY: string;
                        static LAMBDA_DEF: number;
                        static ITERATION_KEY: string;
                        static ITERATION_DEF: number;
                        static THRESHOLD_KEY: string;
                        static THRESHOLD_DEF: number;
                        static LAST_ERR_KEY: string;
                        static WEIGHT_KEY: string;
                        private static INTERNAL_TOTAL_KEY;
                        private static INTERNAL_WEIGHT_BACKUP_KEY;
                        private static MISMATCH_MSG;
                        static NAME: string;
                        private static enforcer;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        learn(output: number, callback: org.mwg.Callback<boolean>): void;
                        internalLearn(input: Float64Array, output: number, callback: org.mwg.Callback<boolean>): void;
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                        private calculate(weights, input);
                        extrapolate(callback: org.mwg.Callback<number>): void;
                    }
                    class PolynomialNode extends org.mwg.ml.AbstractMLNode implements org.mwg.ml.RegressionNode {
                        static PRECISION: string;
                        static PRECISION_DEF: number;
                        static VALUE: string;
                        static NAME: string;
                        static INTERNAL_WEIGHT_KEY: string;
                        static INTERNAL_STEP_KEY: string;
                        private static INTERNAL_TIME_BUFFER;
                        private static INTERNAL_VALUES_BUFFER;
                        private static INTERNAL_NB_PAST_KEY;
                        private static INTERNAL_LAST_TIME_KEY;
                        static MAX_DEGREE: string;
                        static MAX_DEGREE_DEF: number;
                        private static NOT_MANAGED_ATT_ERROR;
                        private static enforcer;
                        private static degenforcer;
                        constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                        setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                        get(propertyName: string): any;
                        learn(value: number, callback: org.mwg.Callback<boolean>): void;
                        private static updateBuffer(state, t, maxdeg, key);
                        extrapolate(callback: org.mwg.Callback<number>): void;
                        private maxErr(precision, degree);
                        private tempError(computedWeights, times, values);
                        toString(): string;
                    }
                }
            }
            module analytics {
                class AttributeNode extends org.mwg.ml.AbstractMLNode {
                    static NAME: string;
                    static VALUE: string;
                    static VALID_VALUE: string;
                    static IS_VALID: string;
                    static EXTRAPOLATE: string;
                    static MIN_TOLERATED: string;
                    static MAX_TOLERATED: string;
                    static MIN_OBSERVED: string;
                    static MAX_OBSERVED: string;
                    static MIN_VALID: string;
                    static MAX_VALID: string;
                    static AVG: string;
                    static SIGMA: string;
                    static TOTAL: string;
                    static TOTAL_VALID: string;
                    private static INTERNAL_SUM_KEY;
                    private static INTERNAL_SUMSQUARE_KEY;
                    private static NOT_MANAGED_ATT_ERROR;
                    constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                    setProperty(propertyName: string, propertyType: number, propertyValue: any): void;
                    get(propertyName: string): any;
                    private getValue();
                    private getValidValue();
                    private getAvg();
                    private getSigma();
                    private checkValid(v, min, max);
                    private internalSet(v, callback);
                }
            }
            module common {
                class DecisionTreeNode {
                    boundary: number;
                    classNum: number;
                    left: org.mwg.ml.common.DecisionTreeNode;
                    right: org.mwg.ml.common.DecisionTreeNode;
                    featureNum: number;
                    private static ELEMENTS_PER_NODE;
                    static deserializeFromDoubleArray(decisionTreeArray: Float64Array): org.mwg.ml.common.DecisionTreeNode;
                    static deserializeFromDoubleArrayWithRoot(decisionTreeArray: Float64Array, rootIndex: number): org.mwg.ml.common.DecisionTreeNode;
                    serializeToDoubleArray(): Float64Array;
                    private serializeToDoubleObjectArray();
                }
                module distance {
                    class GaussianDistance implements org.mwg.structure.distance.Distance {
                        err: Float64Array;
                        constructor(covariance: Float64Array);
                        measure(x: Float64Array, y: Float64Array): number;
                        compare(x: number, y: number): boolean;
                        getMinValue(): number;
                        getMaxValue(): number;
                    }
                }
                module matrix {
                    class HybridMatrixEngine implements org.mwg.ml.common.matrix.MatrixEngine {
                        private blas;
                        private jama;
                        private static MULT_LIMIT;
                        private static INVERT_LIMIT;
                        private static PINV_LIMIT;
                        private static SOLVELU_LIMIT;
                        private static SOLVEQR_LIMIT;
                        private static SOLVESVD_LIMIT;
                        constructor();
                        multiplyTransposeAlphaBeta(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix, beta: number, matC: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        invert(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        pinv(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        solveLU(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                        solveQR(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                        decomposeSVD(matA: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.SVDDecompose;
                        solve(A: org.mwg.struct.Matrix, B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                    }
                    interface MatrixEngine {
                        multiplyTransposeAlphaBeta(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix, beta: number, matC: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        invert(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        pinv(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        solveLU(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                        solveQR(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                        decomposeSVD(matA: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.SVDDecompose;
                        solve(A: org.mwg.struct.Matrix, B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                    }
                    interface SVDDecompose {
                        factor(A: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.SVDDecompose;
                        getU(): org.mwg.struct.Matrix;
                        getVt(): org.mwg.struct.Matrix;
                        getS(): Float64Array;
                        getSMatrix(): org.mwg.struct.Matrix;
                    }
                    class TransposeType {
                        static NOTRANSPOSE: TransposeType;
                        static TRANSPOSE: TransposeType;
                        equals(other: any): boolean;
                        static _TransposeTypeVALUES: TransposeType[];
                        static values(): TransposeType[];
                    }
                    class VolatileMatrix implements org.mwg.struct.Matrix {
                        private _data;
                        private _nbRows;
                        private _nbColumns;
                        private static _defaultEngine;
                        constructor(backend: Float64Array, p_nbRows: number, p_nbColumns: number);
                        init(rows: number, columns: number): org.mwg.struct.Matrix;
                        data(): Float64Array;
                        rows(): number;
                        columns(): number;
                        get(rowIndex: number, columnIndex: number): number;
                        set(rowIndex: number, columnIndex: number, value: number): org.mwg.struct.Matrix;
                        add(rowIndex: number, columnIndex: number, value: number): org.mwg.struct.Matrix;
                        fill(value: number): org.mwg.struct.Matrix;
                        fillWith(values: Float64Array): org.mwg.struct.Matrix;
                        leadingDimension(): number;
                        unsafeGet(index: number): number;
                        unsafeSet(index: number, value: number): org.mwg.struct.Matrix;
                        static compare(a: Float64Array, b: Float64Array, eps: number): boolean;
                        static compareArray(a: Array<Float64Array>, b: Array<Float64Array>, eps: number): boolean;
                        exportRowMatrix(): Float64Array;
                        importRowMatrix(rowdata: Float64Array, rows: number, columns: number): org.mwg.ml.common.matrix.VolatileMatrix;
                        addAtIndex(index: number, value: number): number;
                        static defaultEngine(): org.mwg.ml.common.matrix.MatrixEngine;
                        static setDefaultEngine(matrixEngine: org.mwg.ml.common.matrix.MatrixEngine): void;
                        static multiply(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        static multiplyTranspose(transA: org.mwg.ml.common.matrix.TransposeType, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        static multiplyTransposeAlpha(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        static multiplyTransposeAlphaBeta(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix, beta: number, matC: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        static invert(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        static pinv(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                        static random(rows: number, columns: number, min: number, max: number): org.mwg.struct.Matrix;
                        static scale(alpha: number, matA: org.mwg.ml.common.matrix.VolatileMatrix): void;
                        static transpose(matA: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        private static transposeSquare(matA, result);
                        private static transposeStandard(matA, result);
                        private static transposeBlock(matA, result);
                        saveToState(): Float64Array;
                        static loadFromState(o: any): org.mwg.ml.common.matrix.VolatileMatrix;
                        static createIdentity(rows: number, columns: number): org.mwg.ml.common.matrix.VolatileMatrix;
                        static compareMatrix(matA: org.mwg.ml.common.matrix.VolatileMatrix, matB: org.mwg.ml.common.matrix.VolatileMatrix): number;
                        static testDimensionsAB(transA: org.mwg.ml.common.matrix.TransposeType, transB: org.mwg.ml.common.matrix.TransposeType, matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix): boolean;
                        static identity(rows: number, columns: number): org.mwg.struct.Matrix;
                        static empty(rows: number, columns: number): org.mwg.struct.Matrix;
                        static wrap(data: Float64Array, rows: number, columns: number): org.mwg.struct.Matrix;
                        static cloneFrom(origin: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                    }
                    module blassolver {
                        class BlasMatrixEngine implements org.mwg.ml.common.matrix.MatrixEngine {
                            private _blas;
                            constructor();
                            setBlas(p_blas: org.mwg.ml.common.matrix.blassolver.blas.Blas): void;
                            getBlas(): org.mwg.ml.common.matrix.blassolver.blas.Blas;
                            multiplyTransposeAlphaBeta(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix, beta: number, matC: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                            invert(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                            pinv(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                            solveQR(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                            decomposeSVD(matA: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.SVDDecompose;
                            solveLU(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                            solve(A: org.mwg.struct.Matrix, B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        }
                        class JobSVD {
                            static All: JobSVD;
                            static None: JobSVD;
                            static Overwrite: JobSVD;
                            static Part: JobSVD;
                            netlib(): string;
                            equals(other: any): boolean;
                            static _JobSVDVALUES: JobSVD[];
                            static values(): JobSVD[];
                        }
                        class LU {
                            private LU;
                            private _blas;
                            private piv;
                            private singular;
                            getLU(): org.mwg.struct.Matrix;
                            constructor(m: number, n: number, blas: org.mwg.ml.common.matrix.blassolver.blas.Blas);
                            static factorize(A: org.mwg.struct.Matrix, blas: org.mwg.ml.common.matrix.blassolver.blas.Blas): org.mwg.ml.common.matrix.blassolver.LU;
                            factor(A: org.mwg.struct.Matrix, factorInPlace: boolean): org.mwg.ml.common.matrix.blassolver.LU;
                            getL(): org.mwg.struct.Matrix;
                            getU(): org.mwg.struct.Matrix;
                            getPivots(): Int32Array;
                            isSingular(): boolean;
                            solve(B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                            transSolve(B: org.mwg.struct.Matrix, trans: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                            invert(A: org.mwg.struct.Matrix): boolean;
                        }
                        class QR {
                            private Q;
                            private R;
                            private _blas;
                            m: number;
                            n: number;
                            k: number;
                            work: Float64Array;
                            workGen: Float64Array;
                            tau: Float64Array;
                            constructor(rows: number, columns: number, blas: org.mwg.ml.common.matrix.blassolver.blas.Blas);
                            static factorize(A: org.mwg.struct.Matrix, workInPlace: boolean, blas: org.mwg.ml.common.matrix.blassolver.blas.Blas): org.mwg.ml.common.matrix.blassolver.QR;
                            factor(matA: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.blassolver.QR;
                            solve(B: org.mwg.struct.Matrix, X: org.mwg.struct.Matrix): void;
                            private solveU(U, b, n, m);
                            getR(): org.mwg.struct.Matrix;
                            getQ(): org.mwg.struct.Matrix;
                        }
                        class SVD implements org.mwg.ml.common.matrix.SVDDecompose {
                            private work;
                            private iwork;
                            private m;
                            private n;
                            private vectors;
                            private job;
                            private S;
                            private U;
                            private Vt;
                            private _blas;
                            constructor(m: number, n: number, blas: org.mwg.ml.common.matrix.blassolver.blas.Blas);
                            factor(A: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.blassolver.SVD;
                            hasSingularVectors(): boolean;
                            getU(): org.mwg.struct.Matrix;
                            getVt(): org.mwg.struct.Matrix;
                            getS(): Float64Array;
                            getSMatrix(): org.mwg.struct.Matrix;
                        }
                        module blas {
                            interface Blas {
                                dgemm(transA: org.mwg.ml.common.matrix.TransposeType, transB: org.mwg.ml.common.matrix.TransposeType, m: number, n: number, k: number, alpha: number, matA: Float64Array, offsetA: number, ldA: number, matB: Float64Array, offsetB: number, ldB: number, beta: number, matC: Float64Array, offsetC: number, ldC: number): void;
                                dgetrs(transA: org.mwg.ml.common.matrix.TransposeType, dim: number, nrhs: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, matB: Float64Array, offsetB: number, ldB: number, info: Int32Array): void;
                                dgetri(dim: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, work: Float64Array, offsetWork: number, ldWork: number, info: Int32Array): void;
                                dgetrf(rows: number, columns: number, matA: Float64Array, offsetA: number, ldA: number, ipiv: Int32Array, offsetIpiv: number, info: Int32Array): void;
                                dorgqr(m: number, n: number, k: number, matA: Float64Array, offsetA: number, ldA: number, taw: Float64Array, offsetTaw: number, work: Float64Array, offsetWork: number, lWork: number, info: Int32Array): void;
                                dgeqrf(m: number, n: number, matA: Float64Array, offsetA: number, ldA: number, taw: Float64Array, offsetTaw: number, work: Float64Array, offsetwork: number, lWork: number, info: Int32Array): void;
                                dgesdd(jobz: string, m: number, n: number, data: Float64Array, lda: number, s: Float64Array, u: Float64Array, ldu: number, vt: Float64Array, ldvt: number, work: Float64Array, length: number, iwork: Int32Array, info: Int32Array): void;
                                connect(): void;
                                disconnect(): void;
                            }
                            class BlasHelper {
                                private static TRANSPOSE_TYPE_CONJUCATE;
                                private static TRANSPOSE_TYPE_NOTRANSPOSE;
                                private static TRANSPOSE_TYPE_TRANSPOSE;
                                static transTypeToChar(type: org.mwg.ml.common.matrix.TransposeType): string;
                            }
                        }
                    }
                    module jamasolver {
                        class JamaMatrixEngine implements org.mwg.ml.common.matrix.MatrixEngine {
                            multiplyTransposeAlphaBeta(transA: org.mwg.ml.common.matrix.TransposeType, alpha: number, matA: org.mwg.struct.Matrix, transB: org.mwg.ml.common.matrix.TransposeType, matB: org.mwg.struct.Matrix, beta: number, matC: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                            invert(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                            pinv(mat: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.struct.Matrix;
                            solveLU(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                            solveQR(matA: org.mwg.struct.Matrix, matB: org.mwg.struct.Matrix, workInPlace: boolean, transB: org.mwg.ml.common.matrix.TransposeType): org.mwg.struct.Matrix;
                            decomposeSVD(matA: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.SVDDecompose;
                            solve(A: org.mwg.struct.Matrix, B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                        }
                        class LU {
                            private LU;
                            private m;
                            private n;
                            private pivsign;
                            private piv;
                            constructor(A: org.mwg.struct.Matrix);
                            isNonsingular(): boolean;
                            getL(): org.mwg.struct.Matrix;
                            getU(): org.mwg.struct.Matrix;
                            getPivot(): Int32Array;
                            getDoublePivot(): Float64Array;
                            det(): number;
                            solve(B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                            private getMatrix(A, r, j0, j1);
                        }
                        class QR {
                            private QR;
                            private m;
                            private n;
                            private Rdiag;
                            constructor(A: org.mwg.struct.Matrix);
                            isFullRank(): boolean;
                            getH(): org.mwg.struct.Matrix;
                            getR(): org.mwg.struct.Matrix;
                            getQ(): org.mwg.struct.Matrix;
                            solve(B: org.mwg.struct.Matrix): org.mwg.struct.Matrix;
                            private static getMatrix(B, i0, i1, j0, j1);
                        }
                        class SVD implements org.mwg.ml.common.matrix.SVDDecompose {
                            private U;
                            private V;
                            private s;
                            private m;
                            private n;
                            constructor(Arg: org.mwg.struct.Matrix);
                            factor(A: org.mwg.struct.Matrix, workInPlace: boolean): org.mwg.ml.common.matrix.jamasolver.SVD;
                            getU(): org.mwg.struct.Matrix;
                            getVt(): org.mwg.struct.Matrix;
                            getV(): org.mwg.struct.Matrix;
                            getSingularValues(): Float64Array;
                            getSMatrix(): org.mwg.struct.Matrix;
                            getS(): Float64Array;
                            norm2(): number;
                            cond(): number;
                            rank(): number;
                        }
                        class Utils {
                            static hypot(a: number, b: number): number;
                        }
                    }
                    module operation {
                        class Gaussian1D {
                            static getCovariance(sum: number, sumSq: number, total: number): number;
                            static getDensity(sum: number, sumSq: number, total: number, feature: number): number;
                            static getDensityArray(sum: number, sumSq: number, total: number, feature: Float64Array): Float64Array;
                        }
                        class MultivariateNormalDistribution {
                            min: Float64Array;
                            max: Float64Array;
                            means: Float64Array;
                            covDiag: Float64Array;
                            inv: org.mwg.struct.Matrix;
                            covariance: org.mwg.struct.Matrix;
                            pinvsvd: org.mwg.ml.common.matrix.operation.PInvSVD;
                            rank: number;
                            det: number;
                            constructor(means: Float64Array, cov: org.mwg.struct.Matrix, allowSingular: boolean);
                            getMin(): Float64Array;
                            getMax(): Float64Array;
                            getAvg(): Float64Array;
                            getCovDiag(): Float64Array;
                            setMin(min: Float64Array): void;
                            setMax(max: Float64Array): void;
                            static getCovariance(sum: Float64Array, sumsquares: Float64Array, total: number): org.mwg.struct.Matrix;
                            static getDistribution(sum: Float64Array, sumsquares: Float64Array, total: number, allowSingular: boolean): org.mwg.ml.common.matrix.operation.MultivariateNormalDistribution;
                            density(features: Float64Array, normalizeOnAvg: boolean): number;
                            private getExponentTerm(features);
                            clone(avg: Float64Array): org.mwg.ml.common.matrix.operation.MultivariateNormalDistribution;
                            densityExponent(features: Float64Array): number;
                        }
                        class PInvSVD {
                            private _svd;
                            private pinv;
                            private S;
                            private rank;
                            private det;
                            getRank(): number;
                            getDeterminant(): number;
                            constructor();
                            factor(A: org.mwg.struct.Matrix, invertInPlace: boolean): org.mwg.ml.common.matrix.operation.PInvSVD;
                            getSvd(): org.mwg.ml.common.matrix.SVDDecompose;
                            getInvDeterminant(): org.mwg.struct.Matrix;
                            getPInv(): org.mwg.struct.Matrix;
                        }
                        class PolynomialFit {
                            private coef;
                            private degree;
                            constructor(degree: number);
                            getCoef(): Float64Array;
                            fit(samplePoints: Float64Array, observations: Float64Array): void;
                            static extrapolate(time: number, weights: Float64Array): number;
                        }
                    }
                }
            }
            module neuralnet {
                class NeuralNode extends org.mwg.plugin.AbstractNode {
                    static NAME: string;
                    static INPUTS: string;
                    static INPUTS_MAP: string;
                    static OUTPUTS: string;
                    static OUTPUTS_MAP: string;
                    private static WEIGHTS;
                    private static NODE_TYPE;
                    static LEARNINGRATE: string;
                    static LEARNINGRATE_DEF: number;
                    private static random;
                    private static msgIdCounter;
                    constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                    configure(inputs: number, outputs: number, hiddenlayers: number, nodesPerLayer: number): org.mwg.ml.neuralnet.NeuralNode;
                    private initWeightsRadomly(maxValue);
                    private forwardConnect(inputNode);
                    private createNewNode(neuralNodeType);
                    private static integrationFct(values, weights);
                    private static activationFunction(x, type);
                    private static derivateActivationFunction(fctVal, x, type);
                    private static calculateErr(calculated, target);
                    private static calculateDerivativeErr(calculated, target);
                    private generateMsgId();
                    predict(inputs: Float64Array, callback: org.mwg.Callback<Float64Array>): void;
                    learn(inputs: Float64Array, outputs: Float64Array, callback: org.mwg.Callback<Float64Array>): void;
                }
                class NeuralNodeEmpty extends org.mwg.plugin.AbstractNode {
                    static NAME: string;
                    static INPUTS: string;
                    static INPUTS_MAP: string;
                    static OUTPUTS: string;
                    static OUTPUTS_MAP: string;
                    private static WEIGHTS;
                    private static NODE_TYPE;
                    static LEARNINGRATE: string;
                    static LEARNINGRATE_DEF: number;
                    private static random;
                    private static predictTask;
                    constructor(p_world: number, p_time: number, p_id: number, p_graph: org.mwg.Graph);
                    configure(inputs: number, outputs: number, hiddenlayers: number, nodesPerLayer: number): org.mwg.ml.neuralnet.NeuralNodeEmpty;
                    private initWeightsRadomly(maxValue);
                    private forwardConnect(inputNode);
                    private createNewNode(neuralNodeType);
                    private static integrationFct(values, weights);
                    private static activationFunction(x, type);
                    private static derivateActivationFunction(fctVal, x, type);
                    private static calculateErr(calculated, target);
                    private static calculateDerivativeErr(calculated, target);
                    private static createPredictTask();
                    predict(inputs: Float64Array, callback: org.mwg.Callback<Float64Array>): void;
                    learn(inputs: Float64Array, outputs: Float64Array, callback: org.mwg.Callback<Float64Array>): void;
                }
                class NeuralNodeType {
                    static HIDDEN: number;
                    static INPUT: number;
                    static OUTPUT: number;
                    static ROOT: number;
                }
            }
        }
    }
}
